<script setup lang="ts">
    import { onBeforeMount, ref, computed, watch } from 'vue'
    import { useRoute } from 'vue-router'
    import { ArticleReservation } from '@/logisticServiceOffer/entities/articleReservation/ArticleReservation'
    import { ArticleReservationApi } from '@/logisticServiceOffer/entities/articleReservation/ArticleReservationApi'
    import { printWindow } from '@/shared/helpers/printHelper'
    import { useMsal } from '@/plugins/msal/useMsal'
    import SArticleReservationList from '@/components/stock/SArticleReservationList.vue'
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import SSignatureBlock from '@/components/ui/SSignatureBlock.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import {
        serviceOfferIdInjectionKey,
        serviceOfferTrackingCategoryInjectionKey,
    } from '@/shared/constants'
    import { getAnalyticsProvider } from '@/shared/analytics/AnalyticsProvider'
    import { MouvementDeSortie } from '@/logisticServiceOffer/entities/mouvementDeSortie/MouvementDeSortie'
    import { MouvementDeSortieApi } from '@/logisticServiceOffer/entities/mouvementDeSortie/MouvementDeSortieApi'
    import { useDisplay } from 'vuetify/lib/framework.mjs'
    import {
        dateArrondieAuJour,
        formatageDatePourAffichage,
    } from '@/shared/helpers/dates'
    import { Intervention } from '@/logisticServiceOffer/entities/intervention/Intervention'
    import { InterventionApi } from '@/logisticServiceOffer/entities/intervention/interventionApi'
    import SObjectStatusHistory from '@/shared/objectStatus/components/SObjectStatusHistory.vue'
    import { isDefined, requiredInject } from '@/shared/helpers/types'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import { LoadingManager } from '@/shared/helpers/lifeCycle'

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const loggedInDisplayName = computed(() => {
        return msal.instance.getActiveAccount()?.name
    })
    const name = 'ProvisionRequestDetailsView'
    const { smAndUp } = useDisplay()

    const route = useRoute()

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const serviceOfferTrackingCategory = requiredInject(
        serviceOfferTrackingCategoryInjectionKey
    )

    const interventionId = computed(() => <string>route.params.interventionId)
    const articleReservations = ref<ArticleReservation[] | undefined>(undefined)
    const intervention = ref<Intervention | undefined>()
    const mouvementsDeSortie = ref<MouvementDeSortie[]>()
    const mouvementsDeSortieParDate = computed(() => {
        const mouvementsDeSortieParDateMap = new Map<
            number,
            MouvementDeSortie[]
        >()
        if (mouvementsDeSortie.value === undefined) {
            return undefined
        }
        const mouvementsDeSortieSorted = [...mouvementsDeSortie.value]
        mouvementsDeSortieSorted.sort((a, b) => {
            return b.createdAt.getTime() - a.createdAt.getTime()
        })
        mouvementsDeSortieSorted.forEach((mouvementDeSortie) => {
            const dateDeSortieArrondieAuJour = dateArrondieAuJour(
                mouvementDeSortie.createdAt
            )
            if (
                !mouvementsDeSortieParDateMap.has(
                    dateDeSortieArrondieAuJour.getTime()
                )
            ) {
                mouvementsDeSortieParDateMap.set(
                    dateDeSortieArrondieAuJour.getTime(),
                    []
                )
            }
            mouvementsDeSortieParDateMap
                .get(dateDeSortieArrondieAuJour.getTime())
                ?.push(mouvementDeSortie)
        })
        return mouvementsDeSortieParDateMap
    })

    const interventionApi = new InterventionApi(msal)
    const mouvementDeSortieApi = new MouvementDeSortieApi(msal)
    const articleReservationApi = new ArticleReservationApi(msal)

    const mouvementsDeSortieIdAImprimer = ref<MouvementDeSortie['id'][]>([])
    const joursDeSortieTimeStampAImprimer = ref<number[]>([])
    const toggleAllCheckboxes = (jourDeSortieTimeStamp: number) => {
        const isChecked = joursDeSortieTimeStampAImprimer.value?.includes(
            jourDeSortieTimeStamp
        )

        for (const mouvementDeSortie of mouvementsDeSortieParDate.value?.get(
            jourDeSortieTimeStamp
        ) ?? []) {
            const mouvementId = mouvementDeSortie.id
            const index =
                mouvementsDeSortieIdAImprimer.value?.indexOf(mouvementId)

            if (isChecked && index === -1) {
                mouvementsDeSortieIdAImprimer.value?.push(mouvementId)
            } else if (!isChecked && index !== -1) {
                mouvementsDeSortieIdAImprimer.value?.splice(index, 1)
            }
        }
    }
    async function loadIntervention() {
        intervention.value = await interventionApi.get(
            serviceOfferId.value,
            interventionId.value
        )
    }

    async function loadArticleReservations() {
        articleReservations.value =
            await articleReservationApi.findArticleReservationsByIntervention(
                serviceOfferId.value,
                interventionId.value
            )
    }

    async function loadSortiesDeStock() {
        const sortiesDeStock: MouvementDeSortie[] =
            await mouvementDeSortieApi.getAll(
                serviceOfferId.value,
                interventionId.value
            )

        mouvementsDeSortie.value = sortiesDeStock
    }

    const interventionRelatedDataLoadingManager = new LoadingManager()
    function actualiserDatas() {
        const stopLoading = interventionRelatedDataLoadingManager.startLoading()
        Promise.all([
            loadIntervention(),
            loadArticleReservations(),
            loadSortiesDeStock(),
        ]).finally(() => {
            stopLoading()
        })
    }
    onBeforeMount(() => {
        watch(
            [() => msal.accounts, () => userStore.isImpersonating],
            () => {
                actualiserDatas()
            },
            { immediate: true }
        )
    })
</script>

<template>
    <s-contextual-navbar
        :page-title="route.meta.title as string"
        :page-is-loading="interventionRelatedDataLoadingManager.isLoading.value"
    ></s-contextual-navbar>
    <div v-if="intervention" class="d-none d-print-block">
        <div class="d-flex justify-space-between logos mb-3">
            <img
                src="https://silab.grandpoitiers.fr/Apps/_Silab/1/Assets/img/logos/logo-gpcu.jpg"
                alt="logo de la comunauté urbaine de Grand Poitiers"
            />
            <img
                src="https://silab.grandpoitiers.fr/Apps/_Silab/1/Assets/img/logos/logo-ccas-poitiers.png"
                alt="logo du CCAS de Grand Poitiers"
            />
            <img
                src="https://silab.grandpoitiers.fr/Apps/_Silab/1/Assets/img/logos/logo-poitiers.jpg"
                alt="logo de Poitiers"
            />
        </div>
        <h1>
            Sortie de stock du
            {{ formatageDatePourAffichage(new Date(), 'jour') }}
        </h1>
        <div class="mb-4">
            <h2>
                {{ intervention.code }}
                {{ intervention.titre }}
            </h2>
            <p v-if="isDefined(intervention.centreDeCouts)">
                <strong>{{ intervention.centreDeCouts }}</strong>
            </p>
            <p>
                Demandé par <strong>{{ intervention.createdBy }}</strong>
                pour le
                <strong>{{
                    formatageDatePourAffichage(
                        intervention.dateAttendueDeReceptionLaPlusUrgente,
                        'jour'
                    )
                }}</strong>
            </p>
            <div v-if="intervention.equipes.length > 0">
                Équipes concernées :
                <ul>
                    <li
                        v-for="nomÉquipe in intervention.equipes"
                        :key="nomÉquipe"
                        class="ml-5"
                    >
                        {{ nomÉquipe }}
                    </li>
                </ul>
            </div>
            <br />
            <h2 class="text-subtitle-1">Articles sortis</h2>
            <table class="w-100" frame="void" rules="rows">
                <tr class="text-left">
                    <th>Code</th>
                    <th>nom</th>
                    <th>quantité sorties</th>
                </tr>
                <tr
                    v-for="mouvementDeSortie in mouvementsDeSortie?.filter(
                        (mouvement) => {
                            return mouvementsDeSortieIdAImprimer.includes(
                                mouvement.id
                            )
                        }
                    )"
                    :key="mouvementDeSortie.id"
                >
                    <td>
                        <strong>{{ mouvementDeSortie.article.code }}</strong>
                    </td>
                    <td>{{ mouvementDeSortie.article.titre }}</td>
                    <td>
                        {{ mouvementDeSortie.quantité }}
                        {{ mouvementDeSortie.article.unité }}
                    </td>
                </tr>
            </table>
            <br />
            <h2 class="text-subtitle-1">Reste à sortir</h2>
            <table class="w-100" frame="void" rules="rows">
                <tr class="text-left">
                    <th>Code</th>
                    <th>nom</th>
                    <th>quantité réservée</th>
                </tr>
                <tr
                    v-for="articleReservation in articleReservations"
                    :key="articleReservation.id"
                >
                    <td>
                        <strong>{{ articleReservation.articleCode }}</strong>
                    </td>
                    <td>{{ articleReservation.articleDescription }}</td>
                    <td>
                        {{ articleReservation.quantity }}
                        {{ articleReservation.unit }}
                    </td>
                </tr>
            </table>
            <div
                class="d-none d-print-flex justify-end mt-6"
                style="break-inside: avoid"
            >
                <div>
                    <p class="mt-5">
                        Réceptionné par ________________________________
                    </p>
                    <p class="mt-5 mb-3">Le _____/_____/___________</p>
                    <s-signature-block />
                    <p>
                        Préparé par
                        <strong>{{ loggedInDisplayName }}</strong>
                    </p>
                </div>
            </div>
        </div>
        <div
            style="
                position: fixed;
                bottom: 0;
                width: 100%;
                font-size: 0.8em !important;
            "
            class="text-center"
        >
            Bon de sortie de l'intervention
            {{ intervention.code }}
            du {{ formatageDatePourAffichage(new Date(), 'jour') }}
        </div>
    </div>
    <v-main class="d-print-none">
        <s-content-container>
            <div
                v-if="intervention"
                class="mb-4"
                :data-cy="`view-${name}-${intervention.id}`"
            >
                <h2 data-cy="code-and-title">
                    {{ intervention.code }}
                    {{ intervention.titre }}
                </h2>
                <p
                    v-if="isDefined(intervention.centreDeCouts)"
                    data-cy="direction-name"
                >
                    <strong>{{ intervention.centreDeCouts }}</strong>
                </p>
                <p data-cy="creator-name">
                    Demandé par <strong>{{ intervention.createdBy }}</strong>
                    pour le
                    <strong data-cy="expected-receipt-date">{{
                        formatageDatePourAffichage(
                            intervention.dateAttendueDeReceptionLaPlusUrgente,
                            'jour'
                        )
                    }}</strong>
                </p>
                <div v-if="intervention.equipes.length > 0">
                    Équipes concernées :
                    <ul>
                        <li
                            v-for="nomÉquipe in intervention.equipes"
                            :key="nomÉquipe"
                            class="ml-5"
                        >
                            {{ nomÉquipe }}
                        </li>
                    </ul>
                </div>
                <br />
                <s-object-status-history
                    v-if="isDefined(intervention.historiqueDesEtats)"
                    :object-status-history="intervention.historiqueDesEtats"
                />
            </div>
            <div v-else>
                <v-skeleton-loader
                    type="heading, list-item-two-line,list-item-avatar-two-line"
                    max-width="800"
                    height="238"
                ></v-skeleton-loader>
            </div>
            <v-card title="Demandes de fourniture" class="mb-5">
                <template #loader>
                    <v-progress-linear
                        v-if="mouvementsDeSortie === undefined"
                        color="primary"
                        indeterminate
                    ></v-progress-linear>
                </template>
                <s-article-reservation-list
                    :article-reservations="articleReservations"
                    :service-offer-id="serviceOfferId"
                    @actualiser-les-données="actualiserDatas()"
                />
            </v-card>

            <v-card title="Fournitures sorties">
                <template #loader>
                    <v-progress-linear
                        v-if="mouvementsDeSortie === undefined"
                        color="primary"
                        indeterminate
                    ></v-progress-linear>
                </template>
                <v-list>
                    <v-list-item
                        v-if="mouvementsDeSortie?.length === 0"
                        title="Aucune sortie de stock réalisée sur cette intervention"
                    >
                    </v-list-item>
                    <v-list-item
                        v-else-if="mouvementsDeSortie !== undefined"
                        class="bg-grey-lighten-3"
                    >
                        <div
                            v-if="mouvementsDeSortie.length > 0"
                            class="d-flex flex-sm-row flex-column"
                        >
                            <span
                                class="d-print-none"
                                style="width: 115px"
                            ></span>
                            <v-list-item
                                v-if="smAndUp"
                                title="&LT;code&GT; - &LT;article&GT;"
                                subtitle="<date de sortie>, par <nom>"
                                style="flex-basis: 50%"
                                class="px-0"
                            ></v-list-item>
                            <v-list-item
                                v-if="!smAndUp"
                                style="flex-basis: 50%"
                                class="px-0"
                            >
                                <v-list-item-title class="mb-1">
                                    <div>&LT;code&GT; - &LT;article&GT;</div>
                                    <div>&LT;quantité&GT;</div>
                                    <div>&LT;emplacement&GT;</div>
                                </v-list-item-title>
                                <v-list-item-subtitle>
                                    &LT;date de sortie&GT;, par &LT;nom&GT;
                                </v-list-item-subtitle>
                            </v-list-item>
                            <div
                                v-if="smAndUp"
                                class="d-flex justify-end text-center align-center"
                                style="flex-basis: 100%"
                            >
                                <span
                                    class="d-print-none"
                                    style="flex-basis: 100%"
                                    >Emplacement</span
                                >
                                <span style="flex-basis: 100%">Quantité</span>
                            </div>
                        </div>
                    </v-list-item>
                    <template
                        v-for="[
                            jourDeSortieTimeStamp,
                            mouvementsDeSortiePourUneDate,
                        ] in mouvementsDeSortieParDate"
                        :key="jourDeSortieTimeStamp"
                    >
                        <v-divider></v-divider>
                        <v-list-subheader class="bg-grey-lighten-4">
                            <div class="d-flex align-center">
                                <v-checkbox-btn
                                    v-model="joursDeSortieTimeStampAImprimer"
                                    color="secondary"
                                    :value="jourDeSortieTimeStamp"
                                    class="d-print-none"
                                    @change="
                                        toggleAllCheckboxes(
                                            jourDeSortieTimeStamp
                                        )
                                    "
                                ></v-checkbox-btn>
                                <v-list-item-title class="ml-3">
                                    Sorti
                                    <strong>
                                        {{
                                            new Date().toLocaleDateString() ===
                                            new Date(
                                                jourDeSortieTimeStamp
                                            ).toLocaleDateString()
                                                ? "aujourd'hui"
                                                : ''
                                        }}
                                    </strong>

                                    <template
                                        v-if="
                                            new Date().toLocaleDateString() !==
                                            new Date(
                                                jourDeSortieTimeStamp
                                            ).toLocaleDateString()
                                        "
                                    >
                                        le
                                        <strong>{{
                                            formatageDatePourAffichage(
                                                new Date(jourDeSortieTimeStamp),
                                                'jour'
                                            )
                                        }}</strong>
                                    </template>

                                    ({{ mouvementsDeSortiePourUneDate.length }})
                                </v-list-item-title>
                            </div>
                        </v-list-subheader>

                        <template
                            v-for="mouvementDeSortie in mouvementsDeSortiePourUneDate"
                            :key="mouvementDeSortie.id"
                        >
                            <v-divider></v-divider>
                            <v-list-item
                                data-cy="mouvement-de-l-historique"
                                :active="
                                    mouvementsDeSortieIdAImprimer.includes(
                                        mouvementDeSortie.id
                                    )
                                "
                                class="pl-5"
                            >
                                <template #prepend
                                    ><v-list-item-action
                                        class="d-print-none"
                                        start
                                    >
                                        <v-checkbox-btn
                                            v-model="
                                                mouvementsDeSortieIdAImprimer
                                            "
                                            :value="mouvementDeSortie.id"
                                            color="secondary"
                                        ></v-checkbox-btn> </v-list-item-action
                                ></template>
                                <div class="d-flex flex-sm-row flex-column">
                                    <v-list-item
                                        style="flex-basis: 50%"
                                        class="px-0"
                                    >
                                        <v-list-item-title
                                            data-cy="titre-du-mouvement-de-sortie"
                                            class="text-wrap"
                                        >
                                            <strong>{{
                                                mouvementDeSortie.article.code
                                            }}</strong>
                                            &nbsp;{{
                                                mouvementDeSortie.article.titre
                                            }}
                                        </v-list-item-title>
                                        <v-list-item-title
                                            v-if="!smAndUp"
                                            class="mb-1"
                                            data-cy="quantite-du-mouvement-de-sortie"
                                        >
                                            {{ mouvementDeSortie.quantité }}

                                            {{
                                                mouvementDeSortie.article.unité
                                            }}
                                        </v-list-item-title>
                                        <v-list-item-title
                                            v-if="!smAndUp"
                                            class="mb-1"
                                            data-cy="emplacement-du-mouvement-de-sortie"
                                        >
                                            {{
                                                mouvementDeSortie.emplacement
                                                    ?.code ??
                                                'aucun emplacement'
                                            }}
                                        </v-list-item-title>
                                        <v-list-item-subtitle
                                            class="text-wrap"
                                            data-cy="sous-titre-du-mouvement-de-sortie"
                                            >{{
                                                formatageDatePourAffichage(
                                                    mouvementDeSortie.createdAt,
                                                    'minute'
                                                ) +
                                                ', par ' +
                                                (mouvementDeSortie.createdBy ===
                                                undefined
                                                    ? 'inconnu'
                                                    : mouvementDeSortie.createdBy)
                                            }}
                                        </v-list-item-subtitle>
                                    </v-list-item>
                                    <div
                                        v-if="smAndUp"
                                        class="d-flex justify-end text-center align-center"
                                        style="flex-basis: 100%"
                                    >
                                        <span
                                            style="flex-basis: 100%"
                                            class="d-print-none"
                                            data-cy="emplacement-du-mouvement-de-sortie"
                                            >{{
                                                mouvementDeSortie.emplacement
                                                    ?.code ?? '-'
                                            }}</span
                                        >

                                        <span
                                            style="flex-basis: 50%"
                                            class="pr-2 text-right"
                                            data-cy="qtt-du-mouvement-de-sortie"
                                            >{{
                                                mouvementDeSortie.quantité
                                            }}</span
                                        >
                                        <span
                                            style="flex-basis: 50%"
                                            class="text-grey text-left"
                                            data-cy="unité-du-mouvement-de-sortie"
                                            >{{
                                                mouvementDeSortie.article.unité
                                            }}
                                        </span>
                                    </div>
                                </div>
                            </v-list-item>
                        </template>
                    </template></v-list
                >
            </v-card>
            <div class="d-flex justify-end mt-6 d-print-none">
                <v-btn
                    v-if="intervention"
                    data-cy="print-button"
                    prepend-icon="mdi-printer"
                    color="secondary"
                    @click="
                        () => {
                            getAnalyticsProvider().sendEvent(
                                serviceOfferTrackingCategory,
                                'Impression de bon de sortie',
                                intervention?.code
                            )
                            printWindow()
                        }
                    "
                >
                    Imprimer le rapport
                </v-btn>
            </div>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
<style scoped lang="scss">
    .logos {
        img {
            height: 50px;
        }
    }
</style>
